$DEBUG
C
C  GLAVNI PROGRAM ZA INTEGRACIJU OSCILUJUCIH FUNKCIJA
C  DQAGS I DQEXT
C
      DOUBLE PRECISION ABSEPS, ABSERR, ALIST, AREA, A, BLIST,
     *  B, DABS, ELIST, EPSABS, ERR, F, RESEPS, RESULT,PSUM(102),
     *  RES3LA(3), RLIST, ZEROg
C
      EXTERNAL F
C
C  INITIALIZE
      EPSABS = 1.0D-18
      RESULT = 0.0D+00
      A=0.0D+00
      NRES = 0
      NEV = 0
      NUMRL2=0
      OPEN(6, FILE='HANKELg.OUT')
      WRITE(6,800)
C  GLAVNA DO-PETLJA
      DO 100 L=1,99
C  COMPUTE THE L-TH POSITIVE ZERO OF THE BESSEL FUNCTION JN
        B = ZEROg(2,L)
C INTEGRATE FROM A TO B
        CALL QAGS(F,A,B,EPSABS,0.0D+00,AREA,ABSERR,NEVAL,IER)
C
        A=B
        NEV = NEV + NEVAL
C  EXTRAPOLATE
        NUMRL2= NUMRL2+1
        RESULT = RESULT + AREA
        PSUM(NUMRL2) = RESULT
        IF(NUMRL2.LT.3) GO TO 100
C
        CALL QEXT(NUMRL2,PSUM,RESEPS,ABSEPS,RES3LA,NRES)
C
C  AREA = L-TH TERM OF SERIES
C  RESULT = L-TH PARTIAL SUM
C  RESEPS = EXTRAPOLATED RESULT
C  ABSEPS = ESTIMATE OF ABSOLUTE ERROR OF RESEPS
C  NEV = NUMBER OF FUNCTION EVALUATIONS ALREADY USED
        WRITE(6,900) L,AREA,RESULT,RESEPS,ABSEPS,NEV
C TEST OF ACCURACY
C***JUMP OUT OF DO-LOOP
        IF(ABSEPS.LE.EPSABS) GO TO 999
  100 CONTINUE
  999 STOP
  800 FORMAT(1H1,5X,'L',4X,'L TH TERM OF SERIES', 6X,
     *       'L TH PARTIAL SUM',6X,'EXTRAPOLATED RESULT',
     *       3X,'ABS.ERR.EST.',1X,'NUMBER OF'/
     *       1X,60X,'(FROM DQEXT)',6X,'(FROM DQEXT)',2X, 'F-EVAL.',//)
  900 FORMAT(1X,I6,3D24.16,D11.3,I6)
      END
C
      FUNCTION F(X)
      DOUBLE PRECISION F,X,XX,BJ,OMEGA
      OMEGA=20.D0
      XX=OMEGA*DSQRT(X)
      CALL DBESJ(XX,0,BJ,1.D-30,IER)
      F=DEXP(-X*X)*X*BJ*DSIN(X*X)
C(G1)  F=DEXP(-X)*BJ*DSIN(X)
      RETURN
      END
