C      SAMPLE PROGRAM ILLUSTRATING THE USE OF QAGE
C
C       INT(ABS(X**2+2*X-2)**(-1/2)dx) from 0 to 1 =
C           /2 - ATAN(2**(-1/2)) + ALOG(3)/3
C                    1.504622
C
        REAL*8 A,ABSERR,ALIST,B,BLIST,ELIST,EPSABS,EPSREL,F,RESULT
        INTEGER IER,IORD,K,KEY,LAST,LIMIT,NEVAL
        DIMENSION ALIST(100),BLIST(100),ELIST(100),IORD(100),RLIST(100)
        EXTERNAL F
C    A AND B ARE THE INTEGRATION LIMITS
        A = 0.D0
        B = 1.D0
C    EPSABS AND EPSREL DETERMINE THE ACCURACY REQUIREMENT
        EPSABS = 0.D0
        EPSREL = 1.0D-4
C    KEY DETERMINES THE DEGREE OF THE LOCAL INTEGRATION RULE
        KEY = 1
C    LIMIT IS A BOUND OF THE NUMBER OF SUBINTERVALS
        LIMIT = 100
C
        CALL QAGE(F,A,B,EPSABS,EPSREL,KEY,LIMIT,RESULT,ABSERR,
     *  NEVAL,IER,ALIST,BLIST,RLIST,ELIST,IORD,LAST)
C
C     PRINT THE RESULT
        WRITE(6,900) RESULT
        WRITE(6,901) ABSERR
        WRITE(6,902) NEVAL
        WRITE(6,903) IER
        WRITE(6,904)
C   PRINT THE SUBINTERVALS AND THEIR INTEGRAL AND
C   ERROR CONTRIBUTIONS
        DO 10 K = 1,LAST
        WRITE(6,905)K,ALIST(IORD(K)),BLIST(IORD(K)),RLIST(IORD(K)),
     *  ELIST(IORD(K))
   10 CONTINUE
  900 FORMAT(26H INTEGRAL APPROXIMATION = ,D24.15)
  901 FORMAT(30H ESTIMATE OF ABSOLUTE ERROR = ,D9.2)
  902 FORMAT(34H NUMBER OF FUNCTION EVALUATIONS = ,I5)
  903 FORMAT(14H ERROR CODE = ,I1)
  904 FORMAT(//10X,22HLIMITS OF SUBINTERVALS,9X,13HINTEGRAL OVER,
     *    3X,10HERROR OVER/41X,11HSUBINTERVAL,5X,11HSUBINTERVAL/)
  905 FORMAT(I3,3(3X,E14.7),3X,D9.2)
      STOP
      END
C=========================================================
        REAL*8 FUNCTION F(X)
        REAL*8 X
        F = 1.D0/DSQRT(DABS(X*X+2.D0*X-2.D0))
        RETURN
        END
C=========================================================
