C	SAMPLE PROGRAM ILLUSTRATING THE USE OF QAGP
C
C	INT(X**3*ALOG((X**2-1)*(X**2-2))dx) from 0 to 3 =
C             61*alog(2) + 77*alog(7)/4 - 27 = 52.740748
C
	REAL*8 A,ABSERR,B,EPSABS,EPSREL,F,POINTS,RESULT
        INTEGER IER,NEVAL,NPTS2
	DIMENSION POINTS(4)
        EXTERNAL F
C    A  AND  B ARE THE INTEGRATION LIMITS
	A = 0.D0
        B = 3.D0
C    POINTS(I), I=1,...,NPTS2-2 ARE THE ABSCISSAE WHERE A DIFFICULTY
C    OF THE INTEGRAND IS SITUATED
	NPTS2 = 4
	POINTS(1) = 1.D0
        POINTS(2) = DSQRT(2.D0)
C    EPSABS AND EPSREL DETERMINE THE ACCURACY REQUIREMENT
	EPSABS = 0.D0
        EPSREL = 1.0D-3
C
	CALL QAGP(F,A,B,NPTS2,POINTS,EPSABS,EPSREL,RESULT,ABSERR,
     *   NEVAL,IER)
C
C     PRINT THE RESULT
	WRITE(6,900) RESULT
        WRITE(6,901) ABSERR
        WRITE(6,902) NEVAL
        WRITE(6,903) IER
  900	FORMAT(26H INTEGRAL APPROXIMATION = ,D24.15)
  901	FORMAT(30H ESTIMATE OF ABSOLUTE ERROR = ,D9.2)
  902	FORMAT(34H NUMBER OF FUNCTION EVALUATIONS = ,I5)
  903	FORMAT(14H ERROR CODE = ,I1)
  	STOP
        END
C=========================================================
        REAL*8 FUNCTION F(X)
        REAL*8 X
        F = X**3*DLOG(DABS((X**2-1.D0)*(X**2-2.D0)))
        RETURN
        END
C=========================================================
