$debug
C            SAMPLE PROGRAM ILLUSTRATING THE USE OF QAWC
C
C          INT(dx/(X*(5*X**3+6)) from -1 to 5  = ALOG(125/631)/18 
C                    -0.08994401
C
        REAL*8 A,ABSERR,B,C,EPSABS,EPSREL,F,RESULT
        INTEGER IER,NEVAL
        EXTERNAL F
C    A AND B ARE THE INTEGRATION LIMITS
        A = -1.D0
        B = 5.D0
C    C IS THE PARAMETER OF THE WEIGTH FUNCTION
        C = 0.0D0
C    EPSABS AND EPSREL DETERMINE THE ACCURACY REQUIREMENT
        EPSABS = 0.D0
        EPSREL = 1.0D-7
C
        CALL QAWC(F,A,B,C,EPSABS,EPSREL,RESULT,ABSERR,NEVAL,
     *   IER)
C
C     PRINT THE RESULT
        WRITE(6,900) RESULT
        WRITE(6,901) ABSERR
        WRITE(6,902) NEVAL
        WRITE(6,903) IER
  900 FORMAT(26H INTEGRAL APPROXIMATION = ,D24.15)
  901 FORMAT(30H ESTIMATE OF ABSOLUTE ERROR = ,D9.2)
  902 FORMAT(34H NUMBER OF FUNCTION EVALUATIONS = ,I5)
  903 FORMAT(14H ERROR CODE = ,I1)
      STOP
      END
C=========================================================
        REAL*8 FUNCTION F(X)
        REAL*8 X
        F = 1.D0/(5.D0*X**3+6.D0)
        RETURN
        END
C=========================================================
