$debug
C        SAMPLE PROGRAM ILLUSTRATING THE USE OF QAWO
C
C        INT(ALOG(X)*SIN(10**X)dx  from 0 to 1 =
C       -(+LOG((10*))/(10*) = -0.1281316
C
        REAL*8 A,ABSERR,B,EPSABS,EPSREL,F,OMEGA,PI,RESULT
        INTEGER IER,INTEGR,NEVAL
        EXTERNAL F
C    A AND B ARE THE INTEGRATION LIMITS
        A = 0.D0
        B = 1.D0
C    OMEGA AND INTEGR DETERMINE THE WEIGTH FUNCTION
        PI = 3.1415926535D0
        OMEGA = 10.D0*PI
        INTEGR = 2
C    EPSABS AND EPSREL DETERMINE THE ACCURACY REQUIREMENT
        EPSABS = 0.D0
        EPSREL = 1.0D-3
C
         CALL QAWO(F,A,B,OMEGA,INTEGR,EPSABS,EPSREL,RESULT,ABSERR,
     *   NEVAL,IER)
C
C     PRINT THE RESULT
        WRITE(6,900) RESULT
        WRITE(6,901) ABSERR
        WRITE(6,902) NEVAL
        WRITE(6,903) IER
  900 FORMAT(26H INTEGRAL APPROXIMATION = ,D24.15)
  901 FORMAT(30H ESTIMATE OF ABSOLUTE ERROR = ,D9.2)
  902 FORMAT(34H NUMBER OF FUNCTION EVALUATIONS = ,I5)
  903 FORMAT(14H ERROR CODE = ,I1)
      STOP
      END
C=========================================================
        REAL*8 FUNCTION F(X)
        REAL*8 X
        F = 0.D0
        IF(X.GT.0.D0) F = DLOG(X)
        RETURN
        END
C=========================================================
