C	SAMPLE PROGRAM ILLUSTRATING THE USE OF QAWS
C
C	INT(ALOG10(X)/(1+(ALOG(X))**2)**2)dx) from 0 to 1 =
C         (Ci(1)*sin(1)+(/2-Si(1))/     0.1892752
C
        REAL*8 A,ABSERR,ALFA,B,BETA,EPSABS,EPSREL,F,RESULT
        INTEGER IER,INTEGR,NEVAL
        EXTERNAL F
C    A AND B ARE THE INTEGRATION LIMITS
        A = 0.D0
        B = 1.D0
C    ALFA, BETA AND INTEGR DETERMINE THE WEIGTH FUNCTION
        ALFA = 0.0D0
        BETA = 0.D0
        INTEGR = 2
C    EPSABS AND EPSREL DETERMINE THE ACCURACY REQUIREMENT
        EPSABS = 0.D0
        EPSREL = 1.0D-3
C
        CALL QAWS(F,A,B,ALFA,BETA,INTEGR,EPSABS,EPSREL,RESULT,
     *   ABSERR,NEVAL,IER)
C
C     PRINT THE RESULT
        WRITE(6,900) RESULT
        WRITE(6,901) ABSERR
        WRITE(6,902) NEVAL
        WRITE(6,903) IER
  900	FORMAT(26H INTEGRAL APPROXIMATION = ,D24.15)
  901	FORMAT(30H ESTIMATE OF ABSOLUTE ERROR = ,D9.2)
  902	FORMAT(34H NUMBER OF FUNCTION EVALUATIONS = ,I5)
  903	FORMAT(14H ERROR CODE = ,I1)
  	STOP
        END
C=========================================================
	REAL*8 FUNCTION F(X)
        REAL*8 X
        F = 0.D0
        IF(X.GT.0.D0) F = 1.D0/(1.0D0 + DLOG(X)**2)**2
        RETURN
        END
C=========================================================
